Index: build/tags
*** nvi-1.79/build/tags	Wed Oct 23 22:53:13 1996
--- nvi-1.79-m17n/build/tags	Wed Aug 20 14:47:25 1997
***************
*** 798,812 ****
  h_int	../cl/cl_main.c	/^h_int(signo)$/
  h_term	../cl/cl_main.c	/^h_term(signo)$/
  h_winch	../cl/cl_main.c	/^h_winch(signo)$/
  idlok	../cl/cl_bsd.c	/^idlok(win, bf)$/
  inc_buf	../vi/v_put.c	/^inc_buf(sp, vp)$/
  inc_err	../vi/v_increment.c	/^inc_err(sp, nret)$/
  inword	../vi/vi.h	/^#define	inword(ch)	(isalnum(ch) || (ch) == '_')$/
  io	../vi/v_itxt.c	/^io(sp, vp, cmd)$/
! isblank	../common/key.h	/^#define	isblank(ch)	((ch) == ' ' || (ch) == '\\t')/
! ishex	../vi/v_increment.c	/^#define	ishex(c)	(isdigit(c) || strchr("abcdefABCD/
! isoctal	../vi/v_increment.c	/^#define	isoctal(c)	(isdigit(c) && (c) != '8' && (c/
  keypad	../cl/cl_bsd.c	/^keypad(a, on)$/
  lcmp	../cl/cl_bsd.c	/^lcmp(a, b)$/
  linear_search	../ex/ex_tag.c	/^linear_search(string, front, back)$/
  log_backward	../common/log.c	/^log_backward(sp, rp)$/
--- 540,580 ----
  h_int	../cl/cl_main.c	/^h_int(signo)$/
  h_term	../cl/cl_main.c	/^h_term(signo)$/
  h_winch	../cl/cl_main.c	/^h_winch(signo)$/
+ hz_to_int	../common/multi_hz.c	/^hz_to_int(sp, e, dst, pdlen, src, slen, pflags, st/
  idlok	../cl/cl_bsd.c	/^idlok(win, bf)$/
  inc_buf	../vi/v_put.c	/^inc_buf(sp, vp)$/
  inc_err	../vi/v_increment.c	/^inc_err(sp, nret)$/
+ int_to_big5	../common/multi_big5.c	/^int_to_big5(sp, e, dst, pdlen, src, slen, pflags, /
+ int_to_euc	../common/multi_euc.c	/^int_to_euc(sp, e, dst, pdlen, src, slen, pflags, s/
+ int_to_eucjp	../common/multi_eucjp.c	/^int_to_eucjp(sp, e, dst, pdlen, src, slen, pflags,/
+ int_to_euctw	../common/multi_euctw.c	/^int_to_euctw(sp, e, dst, pdlen, src, slen, pflags,/
+ int_to_hz	../common/multi_hz.c	/^int_to_hz(sp, e, dst, pdlen, src, slen, pflags, st/
+ int_to_iso2022	../common/multi_iso2022.c	/^int_to_iso2022(sp, e, dst, pdlen, src, slen, pflag/
+ int_to_iso2022kr	../common/multi_iso2022.c	/^int_to_iso2022kr(sp, e, dst, pdlen, src, slen, pfl/
+ int_to_none	../common/multi_none.c	/^int_to_none(sp, e, dst, pdlen, src, slen, pflags, /
+ int_to_sjis	../common/multi_sjis.c	/^int_to_sjis(sp, e, dst, pdlen, src, slen, pflags, /
  inword	../vi/vi.h	/^#define	inword(ch)	(isalnum(ch) || (ch) == '_')$/
  io	../vi/v_itxt.c	/^io(sp, vp, cmd)$/
! isbig5mb1	../common/multibyte.h	/^#define isbig5mb1(c)	(0xa1 <= (c) && (c) <= 0xfe)$/
! isbig5mb2	../common/multibyte.h	/^#define	isbig5mb2(c)	((0x40 <= (c) && (c) <= 0x7e)/
! isblank	../common/key.h	/^#define	isblank(ch)	((ch) == ' ' || (ch) == '\\t')$/
! ischarset	../common/multibyte.h	/^#define	ischarset(ch)	(((ch) & 0x80) && ((ch) < CS/
! isecma	../common/multibyte.h	/^#define isecma(c)	(0x30 <= (c) && (c) <= 0x7f)$/
! iseuckanji	../common/multibyte.h	/^#define	iseuckanji(c)	(0xa1 <= (c) && (c) <= 0xfe)/
! isjishankana	../common/multibyte.h	/^#define isjishankana(c)	(0xa1 <= (c) && (c) <= 0xd/
! iso2022_keyinput	../common/multi_iso2022.c	/^iso2022_keyinput(sp, e, kbuf, kbuflen, intbuf, pin/
! iso2022_to_int	../common/multi_iso2022.c	/^iso2022_to_int(sp, e, dst, pdlen, src, slen, pflag/
! iso2022cn_recommendation	../common/multi_iso2022.c	/^iso2022cn_recommendation(cs, e)$/
! iso2022jp_recommendation	../common/multi_iso2022.c	/^iso2022jp_recommendation(cs, e)$/
! iso2022kr_recommendation	../common/multi_iso2022.c	/^iso2022kr_recommendation(cs, e)$/
! iso2022kr_to_int	../common/multi_iso2022.c	/^iso2022kr_to_int(sp, e, dst, pdlen, src, slen, pfl/
! iso2022tobig5	../common/multi_big5.c	/^iso2022tobig5(dst, class, src)$/
! issjiskanji1	../common/multibyte.h	/^#define	issjiskanji1(c)	((0x81 <= (c) && (c) <= 0x/
! issjiskanji2	../common/multibyte.h	/^#define	issjiskanji2(c)	((0x40 <= (c) && (c) <= 0x/
! jis0208_chclass	../common/multi_chclass.c	/^jis0208_chclass(p, ctxt)$/
! jistosjis	../common/multi_sjis.c	/^jistosjis(dst, src)$/
  keypad	../cl/cl_bsd.c	/^keypad(a, on)$/
+ ksc5601_chclass	../common/multi_chclass.c	/^ksc5601_chclass(p, ctxt)$/
  lcmp	../cl/cl_bsd.c	/^lcmp(a, b)$/
  linear_search	../ex/ex_tag.c	/^linear_search(string, front, back)$/
  log_backward	../common/log.c	/^log_backward(sp, rp)$/
***************
*** 835,847 ****
  msg_open	../common/msg.c	/^msg_open(sp, file)$/
  msg_print	../common/msg.c	/^msg_print(sp, s, needfree)$/
  msghandler	../tcl_api/tcl.c	/^msghandler(sp, mtype, msg, len)$/
! msgq	../common/msg.c	/^msgq(sp, mt, fmt, va_alist)$/
  msgq_status	../common/msg.c	/^msgq_status(sp, lno, flags)$/
  msgq_str	../common/msg.c	/^msgq_str(sp, mtype, str, fmt)$/
  newterm	../cl/cl_bsd.c	/^newterm(a, b, c)$/
  nget_slong	../common/util.c	/^nget_slong(valp, p, endp, base)$/
  nget_uslong	../common/util.c	/^nget_uslong(valp, p, endp, base)$/
  nonblank	../common/util.c	/^nonblank(sp, lno, cnop)$/
  noprev	../vi/v_ch.c	/^noprev(sp)$/
  notfound	../vi/v_ch.c	/^notfound(sp, ch)$/
  o_set	../common/options.c	/^o_set(sp, opt, flags, str, val)$/
--- 603,648 ----
  msg_open	../common/msg.c	/^msg_open(sp, file)$/
  msg_print	../common/msg.c	/^msg_print(sp, s, needfree)$/
  msghandler	../tcl_api/tcl.c	/^msghandler(sp, mtype, msg, len)$/
! msgq	../common/msg.c	/^msgq(SCR *sp, mtype_t mt, const char *fmt, ...)$/
  msgq_status	../common/msg.c	/^msgq_status(sp, lno, flags)$/
  msgq_str	../common/msg.c	/^msgq_str(sp, mtype, str, fmt)$/
+ multi_Wordbound	../common/multibyte.c	/^multi_Wordbound(c1, c2, forward)$/
+ multi_back	../common/multibyte.c	/^multi_back(sp, p0, p)$/
+ multi_byte	../common/multibyte.c	/^multi_byte(sp, p)$/
+ multi_byte_c	../common/multibyte.c	/^multi_byte_c(sp, arg)$/
+ multi_chclass	../common/multi_chclass.c	/^multi_chclass(p, ctxt)$/
+ multi_cnvfinish	../common/multibyte.c	/^multi_cnvfinish(sp, extra)$/
+ multi_cnvstart	../common/multibyte.c	/^multi_cnvstart(sp, encoding)$/
+ multi_ext2int_region	../common/multibyte.c	/^multi_ext2int_region(sp, mstart, mend, opt, autode/
+ multi_ext2int_text	../common/multibyte.c	/^multi_ext2int_text(sp, tiqh, opt)$/
+ multi_findencoding	../common/multibyte.c	/^multi_findencoding(p)$/
+ multi_fix	../common/multibyte.c	/^multi_fix(sp, p0, p)$/
+ multi_initstate	../common/multibyte.c	/^multi_initstate(sp, e, state)$/
+ multi_int2ext	../common/multibyte.c	/^multi_int2ext(sp, p0, len, ilen, extra)$/
+ multi_int2extlen	../common/multibyte.c	/^multi_int2extlen(sp, p0, len, pflags, extra)$/
+ multi_isencoding	../common/multibyte.c	/^multi_isencoding(p, opt)$/
+ multi_isnone	../common/multibyte.c	/^multi_isnone(sp, ch)$/
+ multi_iswestern	../common/multibyte.c	/^multi_iswestern(sp, ch)$/
+ multi_keyinput	../common/multibyte.c	/^multi_keyinput(sp, kbuf, pkbuflen, intbuf, pintbuf/
+ multi_keyinput_resetstate	../common/multibyte.c	/^multi_keyinput_resetstate(sp)$/
+ multi_len	../common/multibyte.c	/^multi_len(sp, p)$/
+ multi_len_c	../common/multibyte.c	/^multi_len_c(sp, arg)$/
+ multi_name	../common/multibyte.c	/^multi_name(sp, p)$/
+ multi_predict_big5	../common/multibyte.c	/^multi_predict_big5(sp, p, len)$/
+ multi_predict_euc	../common/multibyte.c	/^multi_predict_euc(sp, p, len)$/
+ multi_predict_euctw	../common/multibyte.c	/^multi_predict_euctw(sp, p, len)$/
+ multi_predict_hz	../common/multibyte.c	/^multi_predict_hz(sp, p, len)$/
+ multi_predict_iso2022	../common/multibyte.c	/^multi_predict_iso2022(sp, p, len)$/
+ multi_predict_region	../common/multibyte.c	/^multi_predict_region(sp, mstart, mend, ename, auto/
+ multi_predict_sjis	../common/multibyte.c	/^multi_predict_sjis(sp, p, len)$/
+ multi_rawname	../common/multibyte.c	/^multi_rawname(sp, p)$/
+ multi_wordbound	../common/multibyte.c	/^multi_wordbound(c1, c2, forward)$/
  newterm	../cl/cl_bsd.c	/^newterm(a, b, c)$/
  nget_slong	../common/util.c	/^nget_slong(valp, p, endp, base)$/
  nget_uslong	../common/util.c	/^nget_uslong(valp, p, endp, base)$/
  nonblank	../common/util.c	/^nonblank(sp, lno, cnop)$/
+ none_keyinput	../common/multi_none.c	/^none_keyinput(sp, e, kbuf, kbuflen, intbuf, pintbu/
+ none_to_int	../common/multi_none.c	/^none_to_int(sp, e, dst, pdlen, src, slen, pflags, /
  noprev	../vi/v_ch.c	/^noprev(sp)$/
  notfound	../vi/v_ch.c	/^notfound(sp, ch)$/
  o_set	../common/options.c	/^o_set(sp, opt, flags, str, val)$/
***************
*** 858,868 ****
--- 659,673 ----
  opts_search	../common/options.c	/^opts_search(name)$/
  opts_set	../common/options.c	/^opts_set(sp, argv, usage)$/
  parse	../ex/ex_cscope.c	/^parse(sp, csc, tqp, matchesp)$/
+ parsecharset	../common/multi_iso2022.c	/^parsecharset(p, len, hcs, pgroup)$/
  perr	../cl/cl_main.c	/^perr(name, msg)$/
  proc_wait	../ex/ex_shell.c	/^proc_wait(sp, pid, cmd, silent, okpipe)$/
  ptym_open	../ex/ex_script.c	/^ptym_open(pts_name)$/
  ptys_open	../ex/ex_script.c	/^ptys_open(fdm, pts_name)$/
  put	../common/put.c	/^put(sp, cbp, namep, cp, rp, append)$/
+ rawdelline	../common/multibyte.c	/^rawdelline(sp, l)$/
+ rawgetline	../common/multibyte.c	/^rawgetline(sp, l, pp, plen)$/
+ rawsetline	../common/multibyte.c	/^rawsetline(sp, l, p, len)$/
  rcv_copy	../common/recover.c	/^rcv_copy(sp, wfd, fname)$/
  rcv_email	../common/recover.c	/^rcv_email(sp, fname)$/
  rcv_gets	../common/recover.c	/^rcv_gets(buf, len, fd)$/
***************
*** 889,894 ****
--- 694,700 ----
  search_busy	../common/search.c	/^search_busy(sp, btype)$/
  search_init	../common/search.c	/^search_init(sp, dir, ptrn, plen, epp, flags)$/
  search_msg	../common/search.c	/^search_msg(sp, msg)$/
+ selcharset	../common/multi_iso2022.c	/^selcharset(cs, e, ht, pmask, state, prefer)$/
  seq_close	../common/seq.c	/^seq_close(gp)$/
  seq_delete	../common/seq.c	/^seq_delete(sp, input, ilen, stype)$/
  seq_dump	../common/seq.c	/^seq_dump(sp, stype, isname)$/
***************
*** 906,911 ****
--- 712,721 ----
  sig_end	../cl/cl_main.c	/^sig_end(gp)$/
  sig_init	../cl/cl_main.c	/^sig_init(gp, sp)$/
  sigmsg	../ex/ex_shell.c	/^sigmsg(signo)$/
+ sjis_display	../common/multi_sjis.c	/^sjis_display(sp, e, name, p)$/
+ sjis_keyinput	../common/multi_sjis.c	/^sjis_keyinput(sp, e, kbuf, kbuflen, intbuf, pintbu/
+ sjis_to_int	../common/multi_sjis.c	/^sjis_to_int(sp, e, dst, pdlen, src, slen, pflags, /
+ sjistojis	../common/multi_sjis.c	/^sjistojis(dst, src)$/
  sscr_check	../ex/ex_script.c	/^sscr_check(sp)$/
  sscr_end	../ex/ex_script.c	/^sscr_end(sp)$/
  sscr_exec	../ex/ex_script.c	/^sscr_exec(sp, lno)$/
***************
*** 951,956 ****
--- 761,767 ----
  text_free	../common/cut.c	/^text_free(tp)$/
  text_init	../common/cut.c	/^text_init(sp, p, len, total_len)$/
  text_lfree	../common/cut.c	/^text_lfree(headp)$/
+ tigetnum	../cl/cl_bsd.c	/^tigetnum(name)$/
  tigetstr	../cl/cl_bsd.c	/^tigetstr(name)$/
  tk_addstr	../tk/tk_funcs.c	/^tk_addstr(sp, str, len)$/
  tk_attr	../tk/tk_funcs.c	/^tk_attr(sp, attribute, on)$/
***************
*** 995,1000 ****
--- 806,812 ----
  txt_fc_col	../vi/v_txt.c	/^txt_fc_col(sp, argc, argv)$/
  txt_hex	../vi/v_txt.c	/^txt_hex(sp, tp)$/
  txt_insch	../vi/v_txt.c	/^txt_insch(sp, tp, chp, flags)$/
+ txt_insmbch	../vi/v_txt.c	/^txt_insmbch(sp, tp, chp, flags)$/
  txt_isrch	../vi/v_txt.c	/^txt_isrch(sp, vp, tp, is_flagsp)$/
  txt_map_end	../vi/v_txt.c	/^txt_map_end(sp)$/
  txt_map_init	../vi/v_txt.c	/^txt_map_init(sp)$/
***************
*** 1053,1058 ****
--- 865,873 ----
  v_exaddr	../vi/v_search.c	/^v_exaddr(sp, vp, dir)$/
  v_exec_ex	../vi/v_ex.c	/^v_exec_ex(sp, vp, exp)$/
  v_exmode	../vi/v_ex.c	/^v_exmode(sp, vp)$/
+ v_fep_force_off	../common/multibyte.c	/^v_fep_force_off(sp)$/
+ v_fep_off	../common/multibyte.c	/^v_fep_off(sp)$/
+ v_fep_on	../common/multibyte.c	/^v_fep_on(sp)$/
  v_filter	../vi/v_ex.c	/^v_filter(sp, vp)$/
  v_first	../vi/v_left.c	/^v_first(sp, vp)$/
  v_fmark	../vi/v_mark.c	/^v_fmark(sp, vp)$/
***************
*** 1070,1080 ****
--- 885,898 ----
  v_isempty	../vi/v_util.c	/^v_isempty(p, len)$/
  v_join	../vi/v_ex.c	/^v_join(sp, vp)$/
  v_key	../vi/vi.c	/^v_key(sp, command_events, evp, ec_flags)$/
+ v_key_blen	../common/key.c	/^v_key_blen(sp, ch)$/
  v_key_cmp	../common/key.c	/^v_key_cmp(ap, bp)$/
  v_key_ilookup	../common/key.c	/^v_key_ilookup(sp)$/
  v_key_init	../common/key.c	/^v_key_init(sp)$/
  v_key_len	../common/key.c	/^v_key_len(sp, ch)$/
+ v_key_len1	../common/key.c	/^v_key_len1(sp, ch)$/
  v_key_name	../common/key.c	/^v_key_name(sp, ach)$/
+ v_key_name1	../common/key.c	/^v_key_name1(sp, ach)$/
  v_key_val	../common/key.c	/^v_key_val(sp, ch)$/
  v_keyval	../common/key.c	/^v_keyval(sp, val, name)$/
  v_keyword	../vi/vi.c	/^v_keyword(sp)$/
Index: cl/cl.h
Prereq: 	10.19 
*** nvi-1.79/cl/cl.h	Wed Oct 23 22:29:51 1996
--- nvi-1.79-m17n/cl/cl.h	Sun Dec 29 18:03:33 1996
***************
*** 12,17 ****
--- 12,23 ----
  typedef struct _cl_private {
  	CHAR_T	 ibuf[256];	/* Input keys. */
  
+ #ifdef MULTIBYTE
+ 	CHAR_T	mbbuf[20];	/* Multibyte backup key buffer. */
+ 	size_t	mbbuflen;
+ 	int	mbstate;
+ #endif
+ 
  	int	 eof_count;	/* EOF count. */
  
  	struct termios orig;	/* Original terminal values. */
Index: cl/cl_funcs.c
Prereq: 	10.50 
*** nvi-1.79/cl/cl_funcs.c	Wed Oct 23 22:29:51 1996
--- nvi-1.79-m17n/cl/cl_funcs.c	Fri Feb 21 23:09:26 1997
***************
*** 35,46 ****
--- 35,54 ----
   * cl_addstr --
   *	Add len bytes from the string at the cursor, advancing the cursor.
   *
+  * PUBLIC: #ifndef MULTIBYTE
   * PUBLIC: int cl_addstr __P((SCR *, const char *, size_t));
+  * PUBLIC: #else
+  * PUBLIC: int cl_addstr __P((SCR *, const CHAR_T *, size_t));
+  * PUBLIC: #endif
   */
  int
  cl_addstr(sp, str, len)
  	SCR *sp;
+ #ifndef MULTIBYTE
  	const char *str;
+ #else
+ 	const CHAR_T *str;
+ #endif
  	size_t len;
  {
  	CL_PRIVATE *clp;
***************
*** 61,68 ****
--- 69,104 ----
  		(void)standout();
  	}
  
+ #ifndef MULTIBYTE
  	if (addnstr(str, len) == ERR)
  		return (1);
+ #else
+     {
+ 	size_t i, j;
+ 	CHAR_T *p;
+ 
+ 	i = 0;
+ 	while (i < len) {
+ 		/* output non multibyte chars by bulk */
+ 		j = 0;
+ 		while (i + j < len && KEY_BLEN(sp, str[i + j]) == 1)
+ 			j++;
+ 		if (j) {
+ 			if (addnstr(&str[i], j) == ERR)
+ 				return 1;
+ 			i += j;
+ 		}
+ 
+ 		/* output single multibyte char */
+ 		if (i < len && 1 < KEY_BLEN(sp, str[i])) {
+ 			p = multi_name(sp, &str[i]);
+ 			if (addnstr(p, strlen(p)) == ERR)
+ 				return 1;
+ 			i += KEY_BLEN(sp, str[i]);
+ 		}
+ 	}
+     }
+ #endif
  
  	if (iv)
  		(void)standend();
***************
*** 301,306 ****
--- 337,343 ----
  		mvchgat(RLNO(sp, LASTLINE(sp)), 0, -1, A_NORMAL, 0, NULL);
  #else
  		for (lno = RLNO(sp, LASTLINE(sp)), col = spcnt = 0;;) {
+ #ifndef MULTIBYTE
  			(void)move(lno, col);
  			ch = winch(stdscr);
  			if (isblank(ch))
***************
*** 311,316 ****
--- 348,357 ----
  					(void)addch(' ');
  				(void)addch(ch);
  			}
+ #else
+ 			/* XXX non-portable */
+ 			stdscr->lines[lno]->line[col].attr &= ~__STANDOUT;
+ #endif /*MULTIBYTE*/
  			if (++col >= sp->cols)
  				break;
  		}
Index: cl/cl_main.c
Prereq: 	10.36 
*** nvi-1.79/cl/cl_main.c	Tue Oct 15 04:04:53 1996
--- nvi-1.79-m17n/cl/cl_main.c	Sun Dec 29 18:46:51 1996
***************
*** 257,262 ****
--- 257,267 ----
  	/* Initialize the list of curses functions. */
  	cl_func_std(gp);
  
+ #ifdef MULTIBYTE
+ 	clp->mbbuflen = 0;
+ 	clp->mbstate = 0;
+ #endif /*MULTIBYTE*/
+ 
  	return (clp);
  }
  
Index: cl/cl_read.c
Prereq: 	10.15 
*** nvi-1.79/cl/cl_read.c	Wed Sep 25 09:49:51 1996
--- nvi-1.79-m17n/cl/cl_read.c	Fri May 23 13:53:09 1997
***************
*** 38,43 ****
--- 38,76 ----
  static input_t	cl_read __P((SCR *,
      u_int32_t, CHAR_T *, size_t, int *, struct timeval *));
  static int	cl_resize __P((SCR *, size_t, size_t));
+ #ifdef MULTIBYTE
+ static void cl_multi_conv __P((SCR *, CL_PRIVATE *, CHAR_T *, int *));
+ #endif
+ 
+ #ifdef MULTIBYTE
+ static void
+ cl_multi_conv(sp, clp, buf, blen)
+ 	SCR *sp;
+ 	CL_PRIVATE *clp;
+ 	CHAR_T *buf;
+ 	int *blen;
+ {
+ 	CHAR_T t[sizeof(clp->ibuf)];	/*XXX*/
+ 	size_t i;
+ 	int j;
+ 	size_t jinc;
+ 
+ 	i = 0;
+ 	j = 0;
+ 	while (i < *blen) {
+ 		clp->mbbuf[clp->mbbuflen++] = buf[i++];
+ 		if (sizeof(clp->mbbuf) <= clp->mbbuflen)
+ 			abort();
+ 		multi_keyinput(sp, clp->mbbuf, &clp->mbbuflen, &t[j], &jinc,
+ 			&clp->mbstate);
+ 		if (jinc)
+ 			j += jinc;
+ 		clp->mbbuf[clp->mbbuflen] = '\0';
+ 	}
+ 	memcpy(buf, t, j);
+ 	*blen = j;
+ }
+ #endif /*MULTIBYTE*/
  
  /*
   * cl_event --
***************
*** 56,61 ****
--- 89,99 ----
  	CL_PRIVATE *clp;
  	size_t lines, columns;
  	int changed, nr;
+ #ifdef MULTIBYTE
+ 	int ms0;
+ 
+ 	ms0 = ms;
+ #endif
  
  	/*
  	 * Queue signal based events.  We never clear SIGHUP or SIGTERM events,
***************
*** 66,73 ****
  		if (F_ISSET(clp, CL_SIGINT)) {
  			F_CLR(clp, CL_SIGINT);
  			evp->e_event = E_INTERRUPT;
! 		} else
  			evp->e_event = E_TIMEOUT;
  		return (0);
  	}
  	if (F_ISSET(clp, CL_SIGHUP | CL_SIGTERM | CL_SIGWINCH)) {
--- 104,125 ----
  		if (F_ISSET(clp, CL_SIGINT)) {
  			F_CLR(clp, CL_SIGINT);
  			evp->e_event = E_INTERRUPT;
! #ifdef CANNA
! 			if (canna_enabled(sp))
! 				canna_force_off(sp);
! #endif /*CANNA*/
! #ifdef MULTIBYTE
! 			/* re-initialize the state. */
! 			clp->mbbuflen = 0;
! 			clp->mbstate = 0;
! #endif /*MULTIBYTE*/
! 		} else {
! #ifdef MULTIBYTE
! 			evp->e_csp = NULL;
! 			evp->e_len = 0;
! #endif /*MULTIBYTE*/
  			evp->e_event = E_TIMEOUT;
+ 		}
  		return (0);
  	}
  	if (F_ISSET(clp, CL_SIGHUP | CL_SIGTERM | CL_SIGWINCH)) {
***************
*** 92,97 ****
--- 144,152 ----
  		}
  	}
  
+ #ifdef MULTIBYTE
+ again:
+ #endif
  	/* Set timer. */
  	if (ms == 0)
  		tp = NULL;
***************
*** 102,110 ****
  	}
  
  	/* Read input characters. */
  	switch (cl_read(sp, LF_ISSET(EC_QUOTED | EC_RAW),
! 	    clp->ibuf, sizeof(clp->ibuf), &nr, tp)) {
  	case INP_OK:
  		evp->e_csp = clp->ibuf;
  		evp->e_len = nr;
  		evp->e_event = E_STRING;
--- 157,205 ----
  	}
  
  	/* Read input characters. */
+ #ifndef MULTIBYTE
  	switch (cl_read(sp, LF_ISSET(EC_QUOTED | EC_RAW),
! 	    clp->ibuf, sizeof(clp->ibuf), &nr, tp))
! #else
! 	/*
! 	 * In multibyte environment, it is possible that the raw bytes
! 	 * to be expanded by external->internal code conversion.
! 	 * Prepare for that by dividing buffer size by 2.
! 	 */
! 	switch (cl_read(sp, LF_ISSET(EC_QUOTED | EC_RAW),
! 	    clp->ibuf, sizeof(clp->ibuf) / 2, &nr, tp))
! #endif /*MULTIBYTE*/
! 	{
  	case INP_OK:
+ #ifdef MULTIBYTE
+ 		cl_multi_conv(sp, clp, &clp->ibuf[0], &nr);
+ 		if (!nr) {
+ 			/*
+ 			 * Sorry we must cheat here...
+ 			 *
+ 			 * 1. If we have timeout value, and keys were eaten
+ 			 *    by multibyte processor, we must cheat as if
+ 			 *    we got a timeout.
+ 			 * 2. If we have escape in multibyte buffer,
+ 			 *    we have to set timeout so that we can recognize
+ 			 *    single escape and escape sequence.
+ 			 */
+ 			if (ms0) {
+ 				evp->e_csp = NULL;
+ 				evp->e_len = 0;
+ 				evp->e_event = E_TIMEOUT;
+ 				break;
+ 			}
+ 
+ 			if (clp->mbbuflen) {
+ 				if (clp->mbbuf[clp->mbbuflen - 1] == '\033')
+ 					ms = O_VAL(sp, O_ESCAPETIME);
+ 				else
+ 					ms = O_VAL(sp, O_KEYTIME) * 100;
+ 			}
+ 			goto again;
+ 		}
+ #endif /*MULTIBYTE*/
  		evp->e_csp = clp->ibuf;
  		evp->e_len = nr;
  		evp->e_event = E_STRING;
***************
*** 118,123 ****
--- 213,225 ----
  	case INP_INTR:
  		goto retest;
  	case INP_TIMEOUT:
+ #ifdef MULTIBYTE
+ 		/* Flush multibyte input buffer if necessery */
+ 		memcpy(clp->ibuf, clp->mbbuf, clp->mbbuflen);
+ 		evp->e_csp = clp->ibuf;
+ 		evp->e_len = clp->mbbuflen;
+ 		clp->mbbuflen = 0;
+ #endif /*MULTIBYTE*/
  		evp->e_event = E_TIMEOUT;
  		break;
  	default:
Index: common/cut.c
Prereq: 	10.10 
*** nvi-1.79/common/cut.c	Fri Oct 18 22:34:34 1996
--- nvi-1.79-m17n/common/cut.c	Mon Nov 25 00:20:22 1996
***************
*** 144,155 ****
--- 144,171 ----
  			if (cut_line(sp, lno, 0, 0, cbp))
  				goto cut_line_err;
  	} else {
+ #ifdef MULTIBYTE
+ 		CHAR_T *p;
+ 
+ 		/* Get the line. */
+ 		if (db_get(sp, fm->lno, DBG_FATAL, &p, NULL))
+ 			return (1);
+ #endif /*MULTIBYTE*/
+ 
  		/*
  		 * Get the first line.  A length of 0 causes cut_line
  		 * to cut from the MARK to the end of the line.
  		 */
+ #ifndef MULTIBYTE
  		if (cut_line(sp, fm->lno, fm->cno, fm->lno != tm->lno ?
  		    ENTIRE_LINE : (tm->cno - fm->cno) + 1, cbp))
+ #else
+ 		if (cut_line(sp, fm->lno, fm->cno,
+ 			fm->lno != tm->lno
+ 			    ? ENTIRE_LINE
+ 			    : (tm->cno - fm->cno) + KEY_BLEN(sp, p[tm->cno]),
+ 			cbp))
+ #endif /*MULTIBYTE*/
  			goto cut_line_err;
  
  		/* Get the intermediate lines. */
***************
*** 158,165 ****
--- 174,187 ----
  				goto cut_line_err;
  
  		/* Get the last line. */
+ #ifndef MULTIBYTE
  		if (tm->lno != fm->lno &&
  		    cut_line(sp, lno, 0, tm->cno + 1, cbp))
+ #else
+ 		if (tm->lno != fm->lno &&
+ 		    cut_line(sp, lno, 0, tm->cno + KEY_BLEN(sp, p[tm->cno]),
+ 			    cbp))
+ #endif /*MULTIBYTE*/
  			goto cut_line_err;
  	}
  
Index: common/cut.h
Prereq: 	10.5 
*** nvi-1.79/common/cut.h	Sun Apr 28 00:25:58 1996
--- nvi-1.79-m17n/common/cut.h	Wed Feb 19 23:52:32 1997
***************
*** 26,32 ****
  /* Lines/blocks of text. */
  struct _text {				/* Text: a linked list of lines. */
  	CIRCLEQ_ENTRY(_text) q;		/* Linked list of text structures. */
! 	char	*lb;			/* Line buffer. */
  	size_t	 lb_len;		/* Line buffer length. */
  	size_t	 len;			/* Line length. */
  
--- 26,32 ----
  /* Lines/blocks of text. */
  struct _text {				/* Text: a linked list of lines. */
  	CIRCLEQ_ENTRY(_text) q;		/* Linked list of text structures. */
! 	CHAR_T	*lb;			/* Line buffer. */
  	size_t	 lb_len;		/* Line buffer length. */
  	size_t	 len;			/* Line length. */
  
Index: common/delete.c
Prereq: 	10.12 
*** nvi-1.79/common/delete.c	Wed Oct 23 22:30:50 1996
--- nvi-1.79-m17n/common/delete.c	Fri Feb 21 23:05:27 1997
***************
*** 39,45 ****
--- 39,49 ----
  {
  	recno_t lno;
  	size_t blen, len, nlen, tlen;
+ #ifndef MULTIBYTE
  	char *bp, *p;
+ #else
+ 	CHAR_T *bp, *p;
+ #endif
  	int eof, rval;
  
  	bp = NULL;
***************
*** 90,104 ****
--- 94,120 ----
  
  	/* Case 3 -- delete within a single line. */
  	if (tm->lno == fm->lno) {
+ #ifdef MULTIBYTE
+ 		int tmchlen;
+ #endif
  		if (db_get(sp, fm->lno, DBG_FATAL, &p, &len))
  			return (1);
  		GET_SPACE_RET(sp, bp, blen, len);
  		if (fm->cno != 0)
  			memcpy(bp, p, fm->cno);
+ #ifndef MULTIBYTE
  		memcpy(bp + fm->cno, p + (tm->cno + 1), len - (tm->cno + 1));
  		if (db_set(sp, fm->lno,
  		    bp, len - ((tm->cno - fm->cno) + 1)))
  			goto err;
+ #else
+ 		tmchlen = KEY_BLEN(sp, p[tm->cno]);
+ 		memcpy(bp + fm->cno, p + (tm->cno + tmchlen),
+ 			len - (tm->cno + tmchlen));
+ 		if (db_set(sp, fm->lno,
+ 		    bp, len - ((tm->cno - fm->cno) + tmchlen)))
+ 			goto err;
+ #endif /*MULTIBYTE*/
  		goto done;
  	}
  
***************
*** 117,130 ****
  	/* Copy the end partial line into place. */
  	if (db_get(sp, tm->lno, DBG_FATAL, &p, &len))
  		goto err;
! 	if (len != 0 && tm->cno != len - 1) {
  		/*
  		 * XXX
  		 * We can overflow memory here, if the total length is greater
  		 * than SIZE_T_MAX.  The only portable way I've found to test
  		 * is depending on the overflow being less than the value.
  		 */
  		nlen = (len - (tm->cno + 1)) + tlen;
  		if (tlen > nlen) {
  			msgq(sp, M_ERR, "002|Line length overflow");
  			goto err;
--- 133,159 ----
  	/* Copy the end partial line into place. */
  	if (db_get(sp, tm->lno, DBG_FATAL, &p, &len))
  		goto err;
! #ifndef MULTIBYTE
! 	if (len != 0 && tm->cno != len - 1)
! #else
! 	if (len != 0 && tm->cno != len - multi_back(sp, p, &p[len]))
! #endif
! 	{
! #ifdef MULTIBYTE
! 		int tmchlen;
! 		tmchlen = KEY_BLEN(sp, p[tm->cno]);
! #endif
  		/*
  		 * XXX
  		 * We can overflow memory here, if the total length is greater
  		 * than SIZE_T_MAX.  The only portable way I've found to test
  		 * is depending on the overflow being less than the value.
  		 */
+ #ifndef MULTIBYTE
  		nlen = (len - (tm->cno + 1)) + tlen;
+ #else
+ 		nlen = (len - (tm->cno + tmchlen)) + tlen;
+ #endif
  		if (tlen > nlen) {
  			msgq(sp, M_ERR, "002|Line length overflow");
  			goto err;
***************
*** 134,141 ****
--- 163,176 ----
  		} else
  			ADD_SPACE_RET(sp, bp, blen, nlen);
  
+ #ifndef MULTIBYTE
  		memcpy(bp + tlen, p + (tm->cno + 1), len - (tm->cno + 1));
  		tlen += len - (tm->cno + 1);
+ #else
+ 		memcpy(bp + tlen, p + (tm->cno + tmchlen),
+ 			len - (tm->cno + tmchlen));
+ 		tlen += len - (tm->cno + tmchlen);
+ #endif /*MULTIBYTE*/
  	}
  
  	/* Set the current line. */
Index: common/exf.c
Prereq: 	10.49 
*** nvi-1.79/common/exf.c	Fri Oct 11 10:33:55 1996
--- nvi-1.79-m17n/common/exf.c	Fri Feb 21 23:43:19 1997
***************
*** 135,140 ****
--- 135,143 ----
  	size_t psize;
  	int fd, exists, open_err, readonly;
  	char *oname, tname[MAXPATHLEN];
+ #ifdef MULTIBYTE
+ 	int notranslation;
+ #endif
  
  	open_err = readonly = 0;
  
***************
*** 145,155 ****
--- 148,174 ----
  	 * because the named file doesn't exist.  So, move boldly forward,
  	 * presuming that there's an error message the user will get to see.
  	 */
+ #ifdef MULTIBYTE
+ 	/*
+ 	 * We must keep in mind that recovery file must NOT be translated
+ 	 * into internal expression.  For that, we remember it by FR_RECOVER2.
+ 	 */
+ #endif /*MULTIBYTE*/
  	if (F_ISSET(frp, FR_RECOVER)) {
  		F_CLR(frp, FR_RECOVER);
+ #ifdef MULTIBYTE
+ 		F_SET(frp, FR_RECOVER2);
+ #endif
  		return (rcv_read(sp, frp));
  	}
  
+ #ifdef MULTIBYTE
+ 	/* 
+ 	 * frp->flags will be cleared by the next sentence...
+ 	 */
+ 	notranslation = F_ISSET(frp, FR_RECOVER2) ? 1 : 0;
+ #endif /*MULTIBYTE*/
+ 
  	/*
  	 * Required FRP initialization; the only flag we keep is the
  	 * cursor information.
***************
*** 402,407 ****
--- 421,441 ----
  	++ep->refcnt;
  	sp->ep = ep;
  	sp->frp = frp;
+ 
+ #ifdef MULTIBYTE
+ 	if (!notranslation) {
+ 		/*
+ 		 * Convert all lines into internal structure.
+ 		 */
+ 		MARK start, end;
+ 
+ 		db_last(sp, &end.lno);
+ 		start.lno = (end.lno == 0 ? 0 : 1);
+ 		start.cno = end.cno = 0;
+ 		multi_ext2int_region(sp, &start, &end, O_FILEENCODING,
+ 			O_STR(sp, O_AUTODETECT), 0, 1);
+ 	}
+ #endif /*MULTIBYTE*/
  
  	/* Set the initial cursor position, queue initial command. */
  	file_cinit(sp);
Index: common/gs.h
Prereq: 	10.34 
*** nvi-1.79/common/gs.h	Wed Sep 25 09:51:24 1996
--- nvi-1.79-m17n/common/gs.h	Fri Feb 21 23:04:21 1997
***************
*** 35,40 ****
--- 35,43 ----
  #define	FR_TMPEXIT	0x0040		/* Modified temporary file, no exit. */
  #define	FR_TMPFILE	0x0080		/* If file has no name. */
  #define	FR_UNLOCKED	0x0100		/* File couldn't be locked. */
+ #ifdef MULTIBYTE
+ #define	FR_RECOVER2	0x0200		/* File is being recovered. */
+ #endif
  	u_int16_t flags;
  };
  
***************
*** 75,81 ****
--- 78,95 ----
  #define	GO_LINES	1		/* Global options: lines. */
  #define	GO_SECURE	2		/* Global options: secure. */
  #define	GO_TERM		3		/* Global options: terminal type. */
+ #ifndef MULTIBYTE
  	OPTION	 opts[GO_TERM + 1];
+ #else
+ #define GO_DISPLAYENCODING	4	/* Global options: display encoding. */
+ # ifndef CANNA
+ 	OPTION	 opts[GO_DISPLAYENCODING + 1];
+ # else
+ #define GO_CANNA		5	/* Global options: canna enabled? */
+ #define GO_CANNASERVER		6	/* Global options: canna server. */
+ 	OPTION	 opts[GO_CANNASERVER + 1];
+ # endif
+ #endif /*MULTIBYTE*/
  
  	DB	*msg;			/* Message catalog DB. */
  	MSGH	 msgq;			/* User message list. */
***************
*** 114,129 ****
--- 128,165 ----
  	LIST_HEAD(_seqh, _seq) seqq;	/* Linked list of maps, abbrevs. */
  	bitstr_t bit_decl(seqb, MAX_BIT_SEQ);
  
+ #ifndef MULTIBYTE
  #define	MAX_FAST_KEY	254		/* Max fast check character.*/
+ #else
+ #define MAX_FAST_KEY	127
+ #endif
+ #ifndef MULTIBYTE
  #define	KEY_LEN(sp, ch)							\
  	((unsigned char)(ch) <= MAX_FAST_KEY ?				\
  	    sp->gp->cname[(unsigned char)ch].len : v_key_len(sp, ch))
  #define	KEY_NAME(sp, ch)						\
  	((unsigned char)(ch) <= MAX_FAST_KEY ?				\
  	    sp->gp->cname[(unsigned char)ch].name : v_key_name(sp, ch))
+ #else
+ #define	KEY_LEN(sp, ch)							\
+ 	((unsigned char)(ch) <= MAX_FAST_KEY				\
+ 	    ? sp->gp->cname[(unsigned char)ch].len			\
+ 	    : v_key_len1(sp, (unsigned char)ch))
+ #define	KEY_NAME(sp, ch)						\
+ 	((unsigned char)(ch) <= MAX_FAST_KEY				\
+ 	    ? sp->gp->cname[(unsigned char)ch].name			\
+ 	    : v_key_name1(sp, (unsigned char)ch))
+ #define KEY_BLEN(sp, ch)						\
+ 	((unsigned char)(ch) <= MAX_FAST_KEY				\
+ 	    ? sp->gp->cname[(unsigned char)ch].blen			\
+ 	    : v_key_blen(sp, (unsigned char)ch))
+ #endif /*MULTIBYTE*/
  	struct {
  		CHAR_T	 name[MAX_CHARACTER_COLUMNS + 1];
  		u_int8_t len;
+ #ifdef MULTIBYTE
+ 		u_int8_t blen;
+ #endif
  	} cname[MAX_FAST_KEY + 1];	/* Fast lookup table. */
  
  #define	KEY_VAL(sp, ch)							\
